=== debian/changelog ===
fscrypt (0.3.5-1syncable1) plucky; urgency=medium

  * Do not make runtime tests fatal on ppc64el.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 22 Mar 2025 20:59:50 -0500

fscrypt (0.3.5-1) unstable; urgency=medium

  * New upstream version 0.3.5
  * d/patches: new patch: dont-fail-tests-on-mlock.patch.
    Don't fail tests when locked memory is unavailable.
    Thanks to Steve Langasek (Closes: #1081220)
  * d/control: bump Standards-Version to 4.7.0

 -- Paride Legovini <paride@debian.org>  Sat, 26 Oct 2024 19:51:27 +0200
